diff --git a/sysdeps/powerpc/powerpc32/backtrace.c b/sysdeps/powerpc/powerpc32/backtrace.c
deleted file mode 100644
index 60314779fe..0000000000
--- a/sysdeps/powerpc/powerpc32/backtrace.c
+++ /dev/null
@@ -1,133 +0,0 @@
-/* Return backtrace of current program state.
-   Copyright (C) 1998-2021 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <https://www.gnu.org/licenses/>.  */
-
-#include <execinfo.h>
-#include <stddef.h>
-#include <string.h>
-#include <signal.h>
-#include <libc-vdso.h>
-
-/* This is the stack layout we see with every stack frame.
-   Note that every routine is required by the ABI to lay out the stack
-   like this.
-
-            +----------------+        +-----------------+
-    %r1  -> | %r1 last frame--------> | %r1 last frame--->...  --> NULL
-            |                |        |                 |
-            | (unused)       |        | return address  |
-            +----------------+        +-----------------+
-*/
-struct layout
-{
-  struct layout *next;
-  void *return_address;
-};
-
-#define SIGNAL_FRAMESIZE 64
-
-/* Since the signal handler is just like any other function it needs to
-   save/restore its LR and it will save it into callers stack frame.
-   Since a signal handler doesn't have a caller, the kernel creates a
-   dummy frame to make it look like it has a caller.  */
-struct signal_frame_32 {
-  char               dummy[SIGNAL_FRAMESIZE];
-  struct sigcontext  sctx;
-  mcontext_t         mctx;
-  /* We don't care about the rest, since IP value is at 'mctx' field.  */
-};
-
-static inline bool
-is_sigtramp_address (void *nip)
-{
-#ifdef HAVE_SIGTRAMP_RT32
-  if (nip == GLRO (dl_vdso_sigtramp_32))
-    return true;
-#endif
-  return false;
-}
-
-struct rt_signal_frame_32 {
-  char               dummy[SIGNAL_FRAMESIZE + 16];
-  siginfo_t          info;
-  ucontext_t         uc;
-  /* We don't care about the rest, since IP value is at 'uc' field.  */
-};
-
-static inline bool
-is_sigtramp_address_rt (void * nip)
-{
-#ifdef HAVE_SIGTRAMP_32
-  if (nip == GLRO (dl_vdso_sigtramp_rt32))
-    return true;
-#endif
-  return false;
-}
-
-int
-__backtrace (void **array, int size)
-{
-  struct layout *current;
-  int count;
-
-  /* Force gcc to spill LR.  */
-  asm volatile ("" : "=l"(current));
-
-  /* Get the address on top-of-stack.  */
-  asm volatile ("lwz %0,0(1)" : "=r"(current));
-
-  for (				count = 0;
-       current != NULL && 	count < size;
-       current = current->next, count++)
-    {
-      gregset_t *gregset = NULL;
-
-      array[count] = current->return_address;
-
-      /* Check if the symbol is the signal trampoline and get the interrupted
-       * symbol address from the trampoline saved area.  */
-      if (is_sigtramp_address (current->return_address))
-	{
-	  struct signal_frame_32 *sigframe =
-	    (struct signal_frame_32*) current;
-          gregset = &sigframe->mctx.gregs;
-        }
-      else if (is_sigtramp_address_rt (current->return_address))
-	{
-	  struct rt_signal_frame_32 *sigframe =
-            (struct rt_signal_frame_32*) current;
-          gregset = &sigframe->uc.uc_mcontext.uc_regs->gregs;
-        }
-      if (gregset)
-	{
-	  if (count + 1 == size)
-	    break;
-	  array[++count] = (void*)((*gregset)[PT_NIP]);
-	  current = (void*)((*gregset)[PT_R1]);
-	}
-    }
-
-  /* It's possible the second-last stack frame can't return
-     (that is, it's __libc_start_main), in which case
-     the CRT startup code will have set its LR to 'NULL'.  */
-  if (count > 0 && array[count-1] == NULL)
-    count--;
-
-  return count;
-}
-weak_alias (__backtrace, backtrace)
-libc_hidden_def (__backtrace)
diff --git a/sysdeps/powerpc/powerpc64/backtrace.c b/sysdeps/powerpc/powerpc64/backtrace.c
deleted file mode 100644
index 37de9b5bdd..0000000000
--- a/sysdeps/powerpc/powerpc64/backtrace.c
+++ /dev/null
@@ -1,117 +0,0 @@
-/* Return backtrace of current program state.
-   Copyright (C) 1998-2021 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Library General Public License as
-   published by the Free Software Foundation; either version 2 of the
-   License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Library General Public License for more details.
-
-   You should have received a copy of the GNU Library General Public
-   License along with the GNU C Library; see the file COPYING.LIB.  If
-   not, see <https://www.gnu.org/licenses/>.  */
-
-#include <stddef.h>
-#include <string.h>
-#include <signal.h>
-#include <stdint.h>
-
-#include <execinfo.h>
-#include <libc-vdso.h>
-
-/* This is the stack layout we see with every stack frame.
-   Note that every routine is required by the ABI to lay out the stack
-   like this.
-
-            +----------------+        +-----------------+
-    %r1  -> | %r1 last frame--------> | %r1 last frame--->...  --> NULL
-            |                |        |                 |
-            | cr save        |        | cr save	  |
-            |                |        |                 |
-            | (unused)       |        | return address  |
-            +----------------+        +-----------------+
-*/
-struct layout
-{
-  struct layout *next;
-  long int condition_register;
-  void *return_address;
-};
-
-/* Since the signal handler is just like any other function it needs to
-   save/restore its LR and it will save it into callers stack frame.
-   Since a signal handler doesn't have a caller, the kernel creates a
-   dummy frame to make it look like it has a caller.  */
-struct signal_frame_64 {
-#define SIGNAL_FRAMESIZE 128
-  char dummy[SIGNAL_FRAMESIZE];
-  ucontext_t uc;
-  /* We don't care about the rest, since the IP value is at 'uc' field.  */
-};
-
-/* Test if the address match to the inside the trampoline code.
-   Up to and including kernel 5.8, returning from an interrupt or syscall to a
-   signal handler starts execution directly at the handler's entry point, with
-   LR set to address of the sigreturn trampoline (the vDSO symbol).
-   Newer kernels will branch to signal handler from the trampoline instead, so
-   checking the stacktrace against the vDSO entrypoint does not work in such
-   case.
-   The vDSO branches with a 'bctrl' instruction, so checking either the
-   vDSO address itself and the next instruction should cover all kernel
-   versions.  */
-static inline bool
-is_sigtramp_address (void *nip)
-{
-#ifdef HAVE_SIGTRAMP_RT64
-  if (nip == GLRO (dl_vdso_sigtramp_rt64) ||
-      nip == GLRO (dl_vdso_sigtramp_rt64) + 4)
-    return true;
-#endif
-  return false;
-}
-
-int
-__backtrace (void **array, int size)
-{
-  struct layout *current;
-  int count;
-
-  /* Force gcc to spill LR.  */
-  asm volatile ("" : "=l"(current));
-
-  /* Get the address on top-of-stack.  */
-  asm volatile ("ld %0,0(1)" : "=r"(current));
-
-  for (				count = 0;
-       current != NULL && 	count < size;
-       current = current->next, count++)
-    {
-      array[count] = current->return_address;
-
-      /* Check if the symbol is the signal trampoline and get the interrupted
-       * symbol address from the trampoline saved area.  */
-      if (is_sigtramp_address (current->return_address))
-        {
-	  struct signal_frame_64 *sigframe = (struct signal_frame_64*) current;
-	  if (count + 1 == size)
-	    break;
-          array[++count] = (void*) sigframe->uc.uc_mcontext.gp_regs[PT_NIP];
-	  current = (void*) sigframe->uc.uc_mcontext.gp_regs[PT_R1];
-	}
-    }
-
-  /* It's possible the second-last stack frame can't return
-     (that is, it's __libc_start_main), in which case
-     the CRT startup code will have set its LR to 'NULL'.  */
-  if (count > 0 && array[count-1] == NULL)
-    count--;
-
-  return count;
-}
-weak_alias (__backtrace, backtrace)
-libc_hidden_def (__backtrace)
diff --git a/sysdeps/unix/sysv/linux/dl-vdso-setup.c b/sysdeps/unix/sysv/linux/dl-vdso-setup.c
index 037a2774b6..b42b9dfe32 100644
--- a/sysdeps/unix/sysv/linux/dl-vdso-setup.c
+++ b/sysdeps/unix/sysv/linux/dl-vdso-setup.c
@@ -71,17 +71,6 @@ PROCINFO_CLASS int (*_dl_vdso_clock_getres_time64) (clockid_t,
 # ifdef HAVE_GET_TBFREQ
 PROCINFO_CLASS uint64_t (*_dl_vdso_get_tbfreq)(void) RELRO;
 # endif
-/* The sigtramp are used on powerpc backtrace without using
-   INLINE_VSYSCALL, so there is no need to set their type.  */
-# ifdef HAVE_SIGTRAMP_RT64
-PROCINFO_CLASS void *_dl_vdso_sigtramp_rt64 RELRO;
-# endif
-# ifdef HAVE_SIGTRAMP_RT32
-PROCINFO_CLASS void *_dl_vdso_sigtramp_rt32 RELRO;
-# endif
-# ifdef HAVE_SIGTRAMP_32
-PROCINFO_CLASS void *_dl_vdso_sigtramp_32 RELRO;
-# endif
 #endif
 
 #undef RELRO
diff --git a/sysdeps/unix/sysv/linux/dl-vdso-setup.h b/sysdeps/unix/sysv/linux/dl-vdso-setup.h
index daf9873c4e..75b00a0046 100644
--- a/sysdeps/unix/sysv/linux/dl-vdso-setup.h
+++ b/sysdeps/unix/sysv/linux/dl-vdso-setup.h
@@ -47,15 +47,6 @@ setup_vdso_pointers (void)
 #ifdef HAVE_GET_TBFREQ
   GLRO(dl_vdso_get_tbfreq) = dl_vdso_vsym (HAVE_GET_TBFREQ);
 #endif
-#ifdef HAVE_SIGTRAMP_RT64
-  GLRO(dl_vdso_sigtramp_rt64) = dl_vdso_vsym (HAVE_SIGTRAMP_RT64);
-#endif
-#ifdef HAVE_SIGTRAMP_RT32
-  GLRO(dl_vdso_sigtramp_rt32) = dl_vdso_vsym (HAVE_SIGTRAMP_RT32);
-#endif
-#ifdef HAVE_SIGTRAMP_32
-  GLRO(dl_vdso_sigtramp_32) = dl_vdso_vsym (HAVE_SIGTRAMP_32);
-#endif
 }
 
 #endif
diff --git a/sysdeps/unix/sysv/linux/powerpc/sysdep.h b/sysdeps/unix/sysv/linux/powerpc/sysdep.h
index 6b99464e61..1b1c8f64ab 100644
--- a/sysdeps/unix/sysv/linux/powerpc/sysdep.h
+++ b/sysdeps/unix/sysv/linux/powerpc/sysdep.h
@@ -252,11 +252,4 @@
 #define HAVE_GETTIMEOFDAY_VSYSCALL      "__kernel_gettimeofday"
 #define HAVE_GET_TBFREQ                 "__kernel_get_tbfreq"
 
-#if defined(__PPC64__) || defined(__powerpc64__)
-# define HAVE_SIGTRAMP_RT64		"__kernel_sigtramp_rt64"
-#else
-# define HAVE_SIGTRAMP_32		"__kernel_sigtramp32"
-# define HAVE_SIGTRAMP_RT32		"__kernel_sigtramp_rt32"
-#endif
-
 #endif /* _LINUX_POWERPC_SYSDEP_H  */